/*
 * memmap.h
 *
 * Copyright (C) 2004-2008 Atmark Techno, Inc.
 *
 */

#ifndef _MEMMAP_H_
#define _MEMMAP_H_

#include <xparameters.h>

#define BOOTLOADER_LOAD_SIZE		(0x100000)
#define GET_LOAD_ADDRESS(a)		((a) - BOOTLOADER_LOAD_SIZE) 

#if defined(XPAR_SPI_0_BASEADDR)
#define SPI_REGISTER_BASEADDR		(XPAR_SPI_0_BASEADDR)
#elif defined(XPAR_SPI_FLASH_BASEADDR)
#define SPI_REGISTER_BASEADDR		(XPAR_SPI_FLASH_BASEADDR)
#elif defined(XPAR_SPI_CNTLR_MEM0_BASEADDR)
#define SPI_REGISTER_BASEADDR		(XPAR_SPI_CNTLR_MEM0_BASEADDR)
#endif

#if defined(XPAR_MPMC_0_MPMC_BASEADDR)
#define SDRAM_BASEADDR			(XPAR_MPMC_0_MPMC_BASEADDR)
#elif defined (XPAR_MPMC_DDR2_MPMC_BASEADDR)
#define SDRAM_BASEADDR			(XPAR_MPMC_DDR2_MPMC_BASEADDR)
#elif defined (XPAR_SDRAM_CONTROLLER_MEM0_BASEADDR)
#define SDRAM_BASEADDR			(XPAR_SDRAM_CONTROLLER_MEM0_BASEADDR)
#elif defined (XPAR_SDRAM_CONTROLLER_BASEADDR)
#define SDRAM_BASEADDR			(XPAR_SDRAM_CONTROLLER_BASEADDR)
#elif defined (XPAR_SDRAM_CONTROLLER_MPMC_BASEADDR)
#define SDRAM_BASEADDR			(XPAR_SDRAM_CONTROLLER_MPMC_BASEADDR)
#elif defined (XPAR_SDRAM_CNTLR_MPMC_BASEADDR)
#define SDRAM_BASEADDR			(XPAR_SDRAM_CNTLR_MPMC_BASEADDR)
#endif
#ifdef SPI_REGISTER_BASEADDR
#if defined(__PPC__) || defined(__powerpc__)
#define BOOTLOADER_LOAD_ADDR	\
	(GET_LOAD_ADDRESS((SDRAM_BASEADDR) + 0x2000000))
#elif defined (__MICROBLAZE__)
#define BOOTLOADER_LOAD_ADDR	\
	(GET_LOAD_ADDRESS((SDRAM_BASEADDR) + 0x1000000))
#endif
#else
#define FLASH_START			(XPAR_SYSTEM_MEMCON_MEM1_BASEADDR)
#define BOOTLOADER_LOAD_ADDR	\
	(GET_LOAD_ADDRESS(XPAR_SDRAM_CONTROLLER_HIGHADDR + 1))
#endif /* !SPI_REGISTER_BASEADDR */

#define BOOTLOADER_SIZE			(0x10000)

#if defined(XPAR_OPB_GPIO_0_BASEADDR)
#define SYSTEM_REGISTER_BASEADDR	(XPAR_OPB_GPIO_0_BASEADDR)
#elif defined(XPAR_GPIO_SYSTEM_BASEADDR)
#define SYSTEM_REGISTER_BASEADDR	(XPAR_GPIO_SYSTEM_BASEADDR)
#endif
#define SYSTEM_REGISTER_RECONFIGURE	(1 << 0)
#define SYSTEM_REGISTER_COMPATIBLE_MODE (1 << 1)
#define SYSTEM_REGISTER_BOOT_MODE	(1 << 2)

#if defined(XPAR_LED_GPIO_BASEADDR)
#define LED_REGISTER_BASEADDR		(XPAR_LED_GPIO_BASEADDR)
#elif defined(XPAR_GPIO_LED_BASEADDR)
#define LED_REGISTER_BASEADDR		(XPAR_GPIO_LED_BASEADDR)
#endif

#if defined(XPAR_CONSOLE_UART_BASEADDR)
#define UART_BASEADDR			(XPAR_CONSOLE_UART_BASEADDR)
#elif defined(XPAR_UART_CONSOLE_BASEADDR)
#define UART_BASEADDR			(XPAR_UART_CONSOLE_BASEADDR)
#endif
#if defined(XPAR_SIL_UART_CONSOLE_BASEADDR)
#define UART2_BASEADDR			(XPAR_SIL_UART_CONSOLE_BASEADDR)
#elif defined(XPAR_OPB_UARTLITE_0_BASEADDR)
#define UART2_BASEADDR			(XPAR_OPB_UARTLITE_0_BASEADDR)
#endif

#endif /* !_MEMMAP_H_ */
